﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private mclasspage As classpage
	Private mcoursepage As coursepage
	Private menrollmentpage As enrollmentpage
	Private mscorepage As scorepage
	Private mstudentpage As studentpage
	Private mtestpage As testpage
	Private clv1 As CustomListView
	Private hsv1 As HorizontalScrollView
	Private numlists As Int
	Private leftpos As Int
	Private rtpermissions As RuntimePermissions
	Public exportfolder As String
	Public importfolder As String
	Private lblhint As Label
	Private lbltext As Label
	Private clvdialog As CustomListView
	Private lbltitle As Label
	Private dialog As B4XDialog
	Private notedialog As B4XDialog
	Private edt1_note As EditText
	Private lblnote_title As Label
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Gradebook")
	' pages
	mclasspage.Initialize
	B4XPages.AddPage("Class",mclasspage)
	mcoursepage.Initialize
	B4XPages.AddPage("Course",mcoursepage)
	menrollmentpage.Initialize
	B4XPages.AddPage("Enrollment",menrollmentpage)
	mscorepage.Initialize
	B4XPages.AddPage("Score",mscorepage)
	mstudentpage.Initialize
	B4XPages.AddPage("Student",mstudentpage)
	mtestpage.Initialize
	B4XPages.AddPage("Test",mtestpage)
	'menu
	menuitem_add(Me, "Class")
	menuitem_add(Me, "Course")
	menuitem_add(Me, "Enrollment")
	menuitem_add(Me, "Score")
	menuitem_add(Me, "Student")
	menuitem_add(Me, "Test")
	' folders
	exportfolder = rtpermissions.GetSafeDirDefaultExternal("Export")
	importfolder = rtpermissions.GetSafeDirDefaultExternal("Import")
	' database
	Main.db.Initialize("gradebook","gradebook.db3",True,False)
	Main.ds.Initialize
	Main.ds.create_tables
	dialog.Initialize(Root)
	dialog.PutAtTop = True
	dialog.BackgroundColor = Colors.LightGray
	dialog.BodyTextColor = Colors.Blue
	notedialog.Initialize(Root)
	notedialog.PutAtTop = True
	notedialog.BackgroundColor = Colors.LightGray
	notedialog.BodyTextColor = Colors.Blue
End Sub
Private Sub B4XPage_Appear
	numlists = Main.db.get_num_rows("class")
	Dim clst As List = Main.ds.get_class_records
	hsv1.Panel.RemoveAllViews
	leftpos = 0dip
	Log(hsv1.Width)
	If numlists > 0 Then
		For i = 1 To numlists
			Dim clv As CustomListView = set_clv(i)
			Dim lbl As Label = set_class_label(clst,i)
			hsv1.Panel.AddView(lbl,leftpos+5dip,0,hsv1.Width-10dip,45dip)
			hsv1.Panel.AddView(clv.AsView,leftpos+5dip,50dip,hsv1.Width-10dip,hsv1.Height)
			clv = fill_clv(i,clv)
			leftpos = leftpos + hsv1.Width
		Next
		hsv1.Panel.Width = ((i-1)*hsv1.Width)
	End If
End Sub
Private Sub B4XPage_Disappear
	Main.db.export_database("gradebook.db3",exportfolder,importfolder,"gradebook.db3")
End Sub
Private Sub set_class_label(clst As List, ind As Int) As Label
	Dim lbl As Label
	lbl.Initialize("lbl")
	lbl.Tag = "c|" & ind
	Dim mclas As class = clst.Get(ind-1)
	lbl.Text = mclas.shortname & " " & mclas.longname & " " & mclas.location & " (id: " & mclas.rowid & " )"
	lbl.TextColor = Colors.Black
	lbl.TextSize = 16
	lbl.Padding = Array As Int (10dip, 10dip, 10dip, 10dip)
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.Color = Colors.ARGB(255,200,201,255)
	Return lbl
End Sub
Private Sub menuitem_add(objpage As Object, itemname As String)
	Private mnuitem As B4AMenuItem = B4XPages.AddMenuItem(objpage,itemname)
	mnuitem.AddToBar = False
End Sub
Sub B4XPage_MenuClick (Tag As String)
	B4XPages.ShowPage(Tag)
End Sub
Private Sub set_clv(ipnl As Int) As CustomListView
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, hsv1.Width, hsv1.Height-60dip)
	p.LoadLayout("clv1_layout")
	clv1.AsView.RemoveViewFromParent
	Return clv1
End Sub
Private Sub fill_clv(icnt As Int, mclv As CustomListView) As CustomListView
	Dim lst As List = Main.ds.get_student_records_by_classid(icnt)
	If lst.Size > 0 Then
		For i = 0 To lst.Size -1
			Dim mstud As student = lst.Get(i)
			Dim mclass As class = Main.ds.get_class_information(mstud.class_id)
			Dim strnote As String = ""
			If Main.ds.student_has_note(mstud.rowid) = True Then strnote = "[note]"
			Dim item As String = mstud.firstname & " " & mstud.lastname & " " & mstud.birthdate & " " & mclass.shortname & " " & strnote
			mclv.AddTextItem(item,mstud.rowid)
			mclv.AsView.SetColorAndBorder(Colors.White,2dip,Colors.Black,5dip)
			'Log(item)
		Next
	End If
	Return mclv
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	'Log("index: " & Index & " value: " & Value)
	show_dialog(Value)
End Sub
Private Sub clv1_ItemLongClick (Index As Int, Value As Object)
	Log("index: " & Index & " value: " & Value)
	show_notedialog(Value)
End Sub
private Sub show_dialog(mrowid As Int)
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 500dip)
	pnl.LoadLayout("dialog_layout")
	clvdialog.Clear
	' student
	Dim pn As Panel = set_dialog_label("Student info")
	clvdialog.Add(pn,"")
	Dim mstudent As student = Main.ds.get_student_information(mrowid)
	Dim pn As Panel = set_dialog_field("firstname",mstudent.firstname)
	clvdialog.Add(pn,mstudent.firstname)
	Dim pn As Panel = set_dialog_field("lastname",mstudent.lastname)
	clvdialog.Add(pn,mstudent.lastname)
	Dim pn As Panel = set_dialog_field("birthdate",mstudent.birthdate)
	clvdialog.Add(pn,mstudent.birthdate)
	' class
	Dim pn As Panel = set_dialog_label("Class info")
	clvdialog.Add(pn,"")
	Dim mclass As class = Main.ds.get_class_information(mstudent.class_id)
	Dim pn As Panel = set_dialog_field("shortname",mclass.shortname)
	clvdialog.Add(pn,mclass.shortname)
	Dim pn As Panel = set_dialog_field("longname",mclass.longname)
	clvdialog.Add(pn,mclass.longname)
	Dim pn As Panel = set_dialog_field("location",mclass.location)
	clvdialog.Add(pn,mclass.location)
	' enrollment
	Dim pn As Panel = set_dialog_label("Enrollment info")
	clvdialog.Add(pn,"")
	Dim lst As List = Main.ds.get_enrollment_information(mrowid)
	If lst.Size > 0 Then
		For i = 0 To lst.Size -1
			Dim rec As String = lst.Get(i)
			Dim flds() As String = Regex.Split(";",rec)
			Dim pn As Panel = set_dialog_field("period",flds(0))
			clvdialog.Add(pn,flds(0))
			Dim pn As Panel = set_dialog_field("name",flds(1))
			clvdialog.Add(pn,flds(1))
			Dim pn As Panel = set_dialog_field("description",flds(2))
			clvdialog.Add(pn,flds(2))			
		Next
	End If
	' tests
	Dim pn As Panel = set_dialog_label("Test info")
	clvdialog.Add(pn,"")
	Dim lst As List = Main.ds.get_student_scores(mrowid)
	If lst.Size > 0 Then
		For i = 0 To lst.Size -1
			Dim rec As String = lst.Get(i)
			' rowid - score - comment - date - time - description - maxscore
			Dim flds() As String = Regex.Split(";",rec)
			Dim pn As Panel = set_dialog_field("date/time",flds(3) & " " & flds(4))
			clvdialog.Add(pn,flds(0))
			Dim pn As Panel = set_dialog_field("description",flds(5))
			clvdialog.Add(pn,flds(0))
			Dim pn As Panel = set_dialog_field("score / maxscore",flds(1) & " / " & flds(6))
			clvdialog.Add(pn,flds(0))
			Dim pn As Panel = set_dialog_field("comment",flds(2))
			clvdialog.Add(pn,flds(0))
		Next
	Else
		Dim pn As Panel = set_dialog_field("no scores available yet","")
		clvdialog.Add(pn,"")
	End If
	' note
	Dim pn As Panel = set_dialog_label("Note info")
	clvdialog.Add(pn,"")
	If Main.ds.student_has_note(mrowid) = True Then
		Dim mnote As note = Main.ds.get_student_note(mrowid)
		Dim strnote As String = mnote.notetext
		strnote = strnote.Replace(Chr(10),"")
		If strnote.Length > 30 Then strnote = strnote.SubString2(0,29) & "..."
		Dim pn As Panel = set_dialog_field("note",strnote)
		clvdialog.Add(pn,mnote.notetext)
	Else
		Dim pn As Panel = set_dialog_field("no note available yet","(long tap on student)")
		clvdialog.Add(pn,"")			
	End If
	lbltitle.Text = "Student information: " & mstudent.firstname & " " & mstudent.lastname
	lbltitle.Padding = Array As Int (3dip, 0dip, 3dip, 0dip)
	clvdialog.Base_Resize(340dip,450dip)
	clvdialog.AsView.Height = 450dip
	Wait For (dialog.ShowCustom(pnl, "OK", "", "")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub
Private Sub set_dialog_field(prompt As String, value As String) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,63dip)
	p.LoadLayout("dialogitem2_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & prompt
	lbltext.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lbltext.Text = value
	Return p
End Sub
Private Sub set_dialog_label(mtext As String) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,30dip)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lbl.Color = Colors.ARGB(255,196,244,184)
	lbl.TextColor = Colors.Black
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.Text = mtext
	p.AddView(lbl,0dip,0dip,340dip,30dip)
	Return p
End Sub
private Sub show_notedialog(mrowid As Int)
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 340dip, 195dip)
	pnl.LoadLayout("notedialog_layout")
	Dim mstudent As student = Main.ds.get_student_information(mrowid)
	lblnote_title.Text = "Note for " & mstudent.firstname & " " & mstudent.lastname
	edt1_note.Gravity = Bit.Or(Gravity.LEFT,Gravity.TOP)
	If Main.ds.student_has_note(mrowid) = True Then
		Dim mnote As note = Main.ds.get_student_note(mrowid)
		edt1_note.Text = mnote.notetext
	Else
		edt1_note.Text = ""
	End If
	Wait For (notedialog.ShowCustom(pnl, "SAVE", "DELETE", "CANCEL")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		Log(edt1_note.Text)
		If Main.ds.student_has_note(mrowid) = True Then
			Main.db.change_record("note",Array As String(edt1_note.Text,mstudent.rowid),mnote.rowid)
			B4XPage_Appear			
		Else
			Main.db.add_record("note",Array As String(edt1_note.Text,mstudent.rowid))
			B4XPage_Appear				
		End If
	End If
	If Result = xui.dialogResponse_Negative Then
		Log("delete note: " & mnote.rowid)
		Main.db.remove_record("note",mnote.rowid)
		B4XPage_Appear
	End If
End Sub
