﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Public sqllib As SQL
End Sub
Public Sub Initialize(folder As String,dbname As String, make As Boolean, reset As Boolean)
	#If B4J
	xui.SetDataFolder(folder)
	#End If
	If reset = True Then
		File.Delete(xui.DefaultFolder,dbname)		' remove db for testing
	End If
	If File.Exists(xui.DefaultFolder,dbname) = False Then
		#If B4J
		sqllib.InitializeSQLite(xui.DefaultFolder,dbname,make)
		#Else
		sqllib.Initialize(xui.DefaultFolder,dbname,make)
		#End If
	Else
		#If B4J
		sqllib.InitializeSQLite(xui.DefaultFolder,dbname,make)
		#Else
		sqllib.Initialize(xui.DefaultFolder,dbname,make)
		#End If
	End If
	Return
End Sub
Public Sub select_query(sql As String) As ResultSet
	Private rs As ResultSet = sqllib.ExecQuery(sql)
	Return rs
End Sub
Public Sub select_query_prepared(sql As String, values() As String) As ResultSet
	Private rs As ResultSet = sqllib.ExecQuery2(sql,values)
	Return rs
End Sub
Public Sub action_query(sql As String, values As List)
	Try
		sqllib.ExecNonQuery2(sql,values)
	Catch
		Log(LastException.Message)
	End Try
	Return
End Sub
Public Sub get_last_rowid(table As String) As Int
	Private rowid As Int = sqllib.ExecQuerySingleResult("SELECT max(rowid) FROM " & table)
	Return rowid
End Sub
Public Sub get_num_rows(table As String) As Int
	Private numrows As Int = sqllib.ExecQuerySingleResult("SELECT count(*) FROM " & table)
	Return numrows
End Sub
Public Sub table_exists(table As String) As Boolean
	Private rs As ResultSet = sqllib.ExecQuery2("SELECT name FROM sqlite_master WHERE type='table' AND name=?",Array As String(table))
	If rs.NextRow Then
		rs.Close
		Return True
	Else
		rs.Close
		Return False
	End If
End Sub
public Sub get_tablenames As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("SELECT name FROM sqlite_master WHERE type ='table' AND name NOT LIKE 'sqlite_%'")
	Do While rs.NextRow
		lst.Add(rs.GetString("name"))
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_fieldnames(table As String) As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("PRAGMA table_info(" & table & ")")
	Do While rs.NextRow
		Dim rec As String = rs.GetString("name").Trim
		lst.Add(rec.Trim)
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_fieldtypes(table As String) As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("PRAGMA table_info(" & table & ")")
	Do While rs.NextRow
		lst.Add(rs.GetString("type"))
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_structure(table As String) As List
	Dim lst As List
	lst.Initialize
	Private rs As ResultSet = sqllib.ExecQuery("PRAGMA table_info(" & table & ")")
	Do While rs.NextRow
		Dim rec As String
		rec = rs.GetString("cid") & "," & rs.GetString("name") & "," & rs.GetString("type") & "," & rs.GetString("pk")
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_records(table As String) As List
	Dim flst As List = get_fieldnames(table)
	flst.InsertAt(0,"rowid")
	'Log(flst)
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM " & table
	Private rs As ResultSet = select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		For i = 0 To flst.Size -1
			Dim fld As String = flst.Get(i)
			If fld.Contains("[") Then
				fld = fld.SubString2(1,fld.Length-1)	' remove []
			End If
			Dim fldvalue As String
			If rs.GetString(fld) <> Null Then
				fldvalue = rs.GetString(fld)
			Else
				fldvalue = "NULL"
			End If
			If fldvalue.Contains(",") Then
				fldvalue = fldvalue.Replace(",","")		' comma is a delimiter
			End If
			fldvalue = fldvalue.Replace(Chr(13) & Chr(10),"")	' CRLF is record delimiter
			If i < flst.Size-1 Then
				rec = rec & fldvalue & ","
			Else
				rec = rec & fldvalue
			End If
		Next
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
public Sub get_records_sorted(table As String,sfld As String) As List
	Dim flst As List = get_fieldnames(table)
	'Log(flst)
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT * FROM " & table & " ORDER BY " & sfld
	Private rs As ResultSet = select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		For i = 0 To flst.Size -1
			Dim fld As String = flst.Get(i)
			If fld.Contains("[") Then
				fld = fld.SubString2(1,fld.Length-1)	' remove []
			End If
			Dim fldvalue As String
			If rs.GetString(fld) <> Null Then
				fldvalue = rs.GetString(fld)
			Else
				fldvalue = "NULL"
			End If
			If fldvalue.Contains(",") Then
				fldvalue = fldvalue.Replace(",","")		' comma is a delimiter
			End If
			fldvalue = fldvalue.Replace(Chr(13) & Chr(10),"")	' CRLF is record delimiter
			If i < flst.Size-1 Then
				rec = rec & fldvalue & ","
			Else
				rec = rec & fldvalue
			End If
		Next
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub find_record(tablename As String, rowid As Int) As List
	Dim flst As List = get_fieldnames(tablename)
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT * FROM " & tablename & " WHERE rowid = ?"
	Private fldarr() As String = Array As String(rowid)
	Private rs As ResultSet = select_query_prepared(sql,fldarr)
	rs.NextRow
	If rs.RowCount < 1 Then
		rs.Close
		Return lst
	End If
	Dim rec As String
	For i = 0 To flst.Size -1
		Dim fld As String = flst.Get(i)
		If fld.Contains("[") Then
			fld = fld.SubString2(1,fld.Length-1)	' remove []
		End If
		If i < flst.Size-1 Then
			rec = rec & rs.GetString(fld) & ","
		Else
			rec = rec & rs.GetString(fld)
		End If
	Next
	lst.Add(rec)
	rs.Close
	Return lst
End Sub
Public Sub add_record(tablename As String, valuelst As List)
	Dim fldlst As List = get_fieldnames(tablename)
	Private sql As String = "INSERT INTO " & tablename & "("
	For i = 0 To fldlst.Size-1
		If i < fldlst.Size-1 Then
			sql = sql & fldlst.Get(i) & ","
		Else
			sql = sql & fldlst.Get(i) & ")"
		End If
	Next
	sql = sql & " VALUES ("
	For i = 0 To fldlst.Size-1
		If i < fldlst.Size-1 Then
			sql = sql & "?,"
		Else
			sql = sql & "?)"

		End If
	Next
	action_query(sql,valuelst)
End Sub
Public Sub change_record(tablename As String, valuelst As List,rowid As Int)
	Dim fldlst As List = get_fieldnames(tablename)
	Private sql As String = "UPDATE " & tablename & " SET "
	For i = 0 To fldlst.Size-1
		If i < fldlst.Size-1 Then
			sql = sql & fldlst.Get(i) & " = ?, "
		Else
			sql = sql & fldlst.Get(i) & " = ? WHERE rowid = " & rowid
		End If
	Next
	Log("change sql: " & sql)
	Log(valuelst)
	action_query(sql,valuelst)
End Sub
Public Sub change_field_content(tablename As String, valuelst As List,rowid As Int,fldname As String)
	Private sql As String = "UPDATE " & tablename & " SET "
	sql = sql & fldname & " = ? WHERE rowid = " & rowid
	action_query(sql,valuelst)
End Sub
Public Sub remove_record(tablename As String,rowid As Int)
	Private sql As String = "DELETE FROM " & tablename & " WHERE rowid = ?"
	Private lst As List = Array As String(rowid)
	action_query(sql,lst)
End Sub
Public Sub export_database(dbname As String, exportfolder As String, importfolder As String,newname As String)
	If File.Exists(xui.DefaultFolder, dbname) = True Then
		Dim inpstr As InputStream = File.OpenInput(xui.DefaultFolder, dbname)
		Dim outstr As OutputStream = File.OpenOutput(exportfolder, newname,False)
		File.Copy2(inpstr,outstr)
		outstr.Close
		' copy to import folder to preserve the changes
'		Dim inpstr As InputStream = File.OpenInput(xui.DefaultFolder, dbname)
'		Dim outstr2 As OutputStream = File.OpenOutput(importfolder, newname,False)
'		File.Copy2(inpstr,outstr2)
'		outstr2.Close
	End If
End Sub
Public Sub import_database(dbname As String,importfolder As String)
	Dim inpstr As InputStream = File.OpenInput(importfolder, dbname)
	Dim outstr As OutputStream = File.OpenOutput(xui.DefaultFolder, dbname,False)
	File.Copy2(inpstr,outstr)
	outstr.Close
End Sub

