﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	
End Sub
Public Sub Initialize
	Return
End Sub
Public Sub create_tables
	If Main.db.table_exists("class") = False Then
		Private sql As String = "CREATE TABLE class (shortname TEXT, longname TEXT, location TEXT)"
		Main.db.action_query(sql,Null)
	End If
	If Main.db.table_exists("course") = False Then
		Private sql As String = "CREATE TABLE course (name TEXT, description TEXT)"
		Main.db.action_query(sql,Null)
	End If
	If Main.db.table_exists("enrollment") = False Then
		Private sql As String = "CREATE TABLE enrollment (period TEXT, course_id INT, student_id INT)"
		Main.db.action_query(sql,Null)
	End If
	If Main.db.table_exists("note") = False Then
		Private sql As String = "CREATE TABLE note (notetext TEXT, student_id INT)"
		Main.db.action_query(sql,Null)
	End If
	If Main.db.table_exists("score") = False Then
		Private sql As String = "CREATE TABLE score (score INT, comment TEXT, student_id INT, test_id INT)"
		Main.db.action_query(sql,Null)
	End If
	If Main.db.table_exists("student") = False Then
		Private sql As String = "CREATE TABLE student (firstname TEXT, lastname TEXT, birthdate TEXT, class_id INT)"
		Main.db.action_query(sql,Null)
	End If
	If Main.db.table_exists("test") = False Then
		Private sql As String = "CREATE TABLE test (date TEXT, time TEXT, description TEXT, maxscore INT, testtype TEXT, course_id INT)"
		Main.db.action_query(sql,Null)
	End If
End Sub
'	declared in the Main page:
'	Type class(rowid As Int, shortname As String, longname As String, location As String)
'	Type course(rowid As Int, name As String, description As String)
'	Type enrollment(rowid As Int, period As String, course_id As Int, student_id As Int)
'	Type note(rowid As Int, notetext As String, student_id As Int)
'	Type score(rowid As Int, score As Int, comment as String, student_id As Int, test_id As Int)
'	Type student(rowid As Int, firstname As String, lastname As String, birthdate As String, class_id As Int)
'	Type test(rowid As Int, date As String, time As String, description As String, maxscore As Int, testtype As String, course_id As Int)
#Region class
Public Sub get_class_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM class"
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim mclass As class
		mclass.rowid = rs.GetString("rowid")
		mclass.shortname = rs.GetString("shortname")
		mclass.longname = rs.GetString("longname")
		mclass.location = rs.GetString("location")
		lst.Add(mclass)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_class_information(mrowid As Int) As class
	Private sql As String = "SELECT rowid, * FROM class WHERE rowid = " & mrowid
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		rs.NextRow
		Dim mclass As class
		mclass.rowid = rs.GetString("rowid")
		mclass.shortname = rs.GetString("shortname")
		mclass.longname = rs.GetString("longname")
		mclass.location = rs.GetString("location")
	End If
	rs.Close
	Return mclass
End Sub
#End Region
#Region course
public Sub get_course_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM course"
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim mcourse As course
		mcourse.rowid = rs.GetString("rowid")
		mcourse.name = rs.GetString("name")
		mcourse.description = rs.GetString("description")
		lst.Add(mcourse)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_course_information(mrowid As Int) As course
	Private sql As String = "SELECT rowid, * FROM course WHERE rowid = " & mrowid
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		rs.NextRow
		Dim mcourse As course
		mcourse.rowid = rs.GetString("rowid")
		mcourse.name = rs.GetString("name")
		mcourse.description = rs.GetString("description")
	End If
	rs.Close
	Return mcourse
End Sub


#End Region
#Region enrollment
Public Sub get_enrollment_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM enrollment"
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim menrollment As enrollment
		menrollment.rowid = rs.GetString("rowid")
		menrollment.period = rs.GetString("period")
		menrollment.course_id = rs.GetString("course_id")
		menrollment.student_id = rs.GetString("student_id")
		lst.Add(menrollment)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_enrollment_information(mstudent_id As Int) As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT period, name, description  "
	sql = sql & " FROM enrollment, course "
	sql = sql & " WHERE enrollment.course_id = course.rowid " 
	sql = sql & " AND student_id = " & mstudent_id
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		rec = rs.GetString("period") & ";" & rs.GetString("name") & ";" & rs.GetString("description")
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
#End Region
#Region note
Public Sub get_note_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM note"
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim mnote As note
		mnote.rowid = rs.GetString("rowid")
		mnote.notetext = rs.GetString("notetext")
		mnote.student_id = rs.GetString("student_id")
		lst.Add(mnote)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_student_note(mstudent_id As Int) As note
	Private sql As String = "SELECT rowid, * FROM note WHERE student_id = " & mstudent_id
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		rs.NextRow
		Dim mnote As note
		mnote.rowid = rs.GetString("rowid")
		mnote.notetext = rs.GetString("notetext")
		mnote.student_id = rs.GetString("student_id")
	End If
	rs.Close
	Return mnote
End Sub
Public Sub student_has_note(mstudent_id As Int) As Boolean
	Private sql As String = "SELECT rowid, * FROM note WHERE student_id = " & mstudent_id
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then Return True
	rs.Close
	Return False
End Sub


#End Region
#Region score
public Sub get_score_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM score"
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim mscore As score
		mscore.rowid = rs.GetString("rowid")
		mscore.score = rs.GetString("score")
		mscore.student_id = rs.GetString("student_id")
		mscore.test_id = rs.GetString("test_id")
		lst.Add(mscore)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_score_information(mtest_id As Int) As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT score.rowid, score, comment, firstname, lastname"
	sql = sql & " FROM score, test, course, enrollment, student "
	sql = sql & " WHERE score.test_id = test.rowid "
	sql = sql & " AND test.course_id = course.rowid "
	sql = sql & " AND enrollment.course_id = course.rowid "
	sql = sql & " AND enrollment.student_id = student.rowid "
	sql = sql & " AND score.test_id = " & mtest_id
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		rec = rs.GetString("rowid") & ";" & rs.GetString("score") & ";" & rs.GetString("comment") & ";" & rs.GetString("firstname") & ";" & rs.GetString("lastname")
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_student_test_score_information(mtest_id As Int, mstudent_id As Int) As score
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM score"
	sql = sql & " WHERE test_id = " & mtest_id
	sql = sql & " AND student_id = " & mstudent_id
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		rs.NextRow
		Dim mscore As score
		mscore.rowid = rs.GetString("rowid")
		mscore.score = rs.GetString("score")
		mscore.comment = rs.GetString("comment")
		mscore.student_id = rs.GetString("student_id")
		mscore.test_id = rs.GetString("test_id")
	Else
		Dim mscore As score
		mscore.Initialize
		mscore.score = -1
		mscore.comment = ""
	End If
	rs.Close
	Return mscore
End Sub


#End Region
#Region student
Public Sub get_student_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM student"
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		Do While rs.NextRow
			Dim mstudent As student
			mstudent.rowid = rs.GetString("rowid")
			mstudent.firstname = rs.GetString("firstname")
			mstudent.lastname = rs.GetString("lastname")
			mstudent.birthdate = rs.GetString("birthdate")
			mstudent.class_id = rs.GetString("class_id")
			lst.Add(mstudent)
		Loop
	End If
	rs.Close
	Return lst
End Sub
Public Sub get_student_records_by_classid(mclassid As Int) As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM student WHERE class_id = " & mclassid
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		Do While rs.NextRow
			Dim mstudent As student
			mstudent.rowid = rs.GetString("rowid")
			mstudent.firstname = rs.GetString("firstname")
			mstudent.lastname = rs.GetString("lastname")
			mstudent.birthdate = rs.GetString("birthdate")
			mstudent.class_id = rs.GetString("class_id")
			lst.Add(mstudent)
		Loop
	End If
	rs.Close
	Return lst
End Sub
Public Sub get_student_information(mrowid As Int) As student
	Private sql As String = "SELECT rowid, * FROM student WHERE rowid = " & mrowid
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		rs.NextRow
		Dim mstudent As student
		mstudent.rowid = rs.GetString("rowid")
		mstudent.firstname = rs.GetString("firstname")
		mstudent.lastname = rs.GetString("lastname")
		mstudent.birthdate = rs.GetString("birthdate")
		mstudent.class_id = rs.GetString("class_id")		
	End If
	rs.Close
	Return mstudent
End Sub
Public Sub get_student_scores(mstudent_id As Int) As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT score.rowid, score, comment, date, time, description, maxscore"
	sql = sql & " FROM score, test"
	sql = sql & " WHERE score.test_id = test.rowid"
	sql = sql & " AND student_id = " & mstudent_id
	Private rs As ResultSet = Main.db.select_query(sql)
	If rs.RowCount > 0 Then
		Do While rs.NextRow
			Dim rec As String
			rec = rs.GetString("rowid") & ";" & rs.GetString("score") & ";" & rs.GetString("comment") & ";" & rs.GetString("date") & ";" & rs.GetString("time") & ";" & rs.GetString("description") & ";" & rs.GetString("maxscore")
			lst.Add(rec)
		Loop
	End If
	rs.Close
	Return lst
End Sub


#End Region
#Region test
public Sub get_test_records As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT rowid, * FROM test"
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim mtest As test
		mtest.rowid = rs.GetString("rowid")
		mtest.date = rs.GetString("date")
		mtest.time = rs.GetString("time")
		mtest.description = rs.GetString("description")
		mtest.maxscore = rs.GetInt("maxscore")
		mtest.testtype = rs.GetString("testtype")
		mtest.course_id = rs.GetString("course_id")
		lst.Add(mtest)
	Loop
	rs.Close
	Return lst
End Sub
Public Sub get_test_participants(mtest_id As Int) As List
	Dim lst As List
	lst.Initialize
	Private sql As String = "SELECT student.rowid, firstname, lastname"
	sql = sql & " FROM test, course, enrollment, student "
	sql = sql & " WHERE test.course_id = course.rowid "
	sql = sql & " AND enrollment.course_id = course.rowid "
	sql = sql & " AND enrollment.student_id = student.rowid "
	sql = sql & " AND test.rowid = " & mtest_id
	Private rs As ResultSet = Main.db.select_query(sql)
	Do While rs.NextRow
		Dim rec As String
		rec = rs.GetString("rowid") & ";" & rs.GetString("firstname") & ";" & rs.GetString("lastname")
		lst.Add(rec)
	Loop
	rs.Close
	Return lst
End Sub


#End Region
