﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private sbtnadd As SwiftButton
	Private dialog As B4XDialog
	Private clvdialog As CustomListView
	Private lbltitle As Label
	Private edt As EditText
	Private lblhint As Label
	Private cbx As B4XComboBox
	Private lblcbx As Label
	Private opendialog As B4XDialog
	Private cbxopen As B4XComboBox
	Private edtopen As EditText
	Private clvenrollment As CustomListView
	Private courseindexes As List
	Private studentindexes As List
	Private cbx1 As B4XComboBox
	Private lblcbx1 As Label
End Sub
Public Sub Initialize As Object
	Return Me
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("enrollmentpage_layout")
	B4XPages.SetTitle(Me,"Gradebook - Enrollment")
	menuitem_add(Me, "CSV import")
	dialog.Initialize(Root)
	dialog.PutAtTop = True
	dialog.BackgroundColor = Colors.LightGray
	dialog.BodyTextColor = Colors.Blue
	opendialog.Initialize(Root)
	opendialog.PutAtTop = True
	opendialog.BackgroundColor = Colors.LightGray
	opendialog.BodyTextColor = Colors.Blue
	courseindexes.Initialize
	studentindexes.Initialize
End Sub
Private Sub B4XPage_Appear
	fill_clvenrollment
End Sub
Private Sub menuitem_add(objpage As Object, itemname As String)
	Private mnuitem As B4AMenuItem = B4XPages.AddMenuItem(objpage,itemname)
	mnuitem.AddToBar = False
End Sub
Sub B4XPage_MenuClick (Tag As String)
	If Tag = "CSV import" Then
		show_opendialog
	End If
End Sub
private Sub fill_clvenrollment
	clvenrollment.Clear
	Dim lst As List = Main.ds.get_enrollment_records
	If lst.Size > 0 Then
		For i = 0 To lst.Size -1
			Dim menrollment As enrollment = lst.Get(i)
			Dim mcourse As course = Main.ds.get_course_information(menrollment.course_id)
			Dim mstudent As student = Main.ds.get_student_information(menrollment.student_id)
			Dim item As String = menrollment.rowid & ". "  & menrollment.period & " " & mcourse.name & " " & mstudent.firstname & " " & mstudent.lastname
			clvenrollment.AddTextItem(item,menrollment)
		Next
	End If
End Sub
Private Sub clvenrollment_ItemClick (Index As Int, Value As Object)
	Log("index: " & Index & " value: " & Value)
	Dim menrollment As enrollment = Value
	show_dialog(menrollment,"change")
End Sub
Private Sub sbtnadd_Click
	Dim menrollment As enrollment
	menrollment.Initialize
	show_dialog(menrollment,"add")
End Sub
private Sub show_dialog(menrollment As enrollment,action As String)
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 200dip)
	pnl.LoadLayout("dialog_layout")
	clvdialog.Clear
	Dim pn As Panel = set_dialog_field("period",menrollment.period,1)
	clvdialog.Add(pn,menrollment.period)
	Dim pn As Panel = set_dialog_combo("course_id",menrollment.course_id,2)
	clvdialog.Add(pn,menrollment.course_id)
	Dim pn As Panel = set_dialog_combo2("student_id",menrollment.student_id,3)
	clvdialog.Add(pn,menrollment.student_id)
	lbltitle.Text = action & " enrollment " & menrollment.period & " " & menrollment.course_id & " " & menrollment.student_id
	lbltitle.Padding = Array As Int (3dip, 0dip, 3dip, 0dip)
	Wait For (dialog.ShowCustom(pnl, "SAVE", "DELETE", "CANCEL")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		Dim valuelst As List = set_values_list
		If action = "change" Then
			Main.db.change_record("enrollment", valuelst,menrollment.rowid)
		Else
			Main.db.add_record("enrollment", valuelst)
		End If
		B4XPage_Appear
	End If
	If Result = xui.dialogResponse_Negative Then
		Dim valuelst As List = set_values_list
		Main.db.remove_record("enrollment",menrollment.rowid)
		B4XPage_Appear
	End If
End Sub
Private Sub set_dialog_field(prompt As String, value As String, fldindex As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,90dip)
	p.LoadLayout("dialogitem_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & prompt
	edt.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	edt.Text = value
	edt.Tag = "edt_" & fldindex
	Return p
End Sub
Private Sub set_values_list As List
	Dim vlst As List
	vlst.Initialize
	For i = 0 To clvdialog.Size -1
		Dim pnlitem As Panel = clvdialog.GetPanel(i)
		For Each vw As View In pnlitem.GetAllViewsRecursive
			Dim tg As String = vw.Tag
			If tg.StartsWith("edt_") Then
				vlst.Add(vw.As(EditText).Text)
			End If
			If tg.StartsWith("lbl_") Then
				lblcbx.text = vw.As(Label).Text
				Dim index As Int = lblcbx.Text
				vlst.Add(courseindexes.Get(index))					
			End If
			If tg.StartsWith("lbl1_") Then
				lblcbx1.text = vw.As(Label).Text
				Dim index As Int = lblcbx1.Text
				vlst.Add(studentindexes.Get(index))
			End If
		Next
	Next
	Log(vlst)
	Return vlst
End Sub
Private Sub set_dialog_combo(prompt As String, value As String, fldindex As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,90dip)
	p.LoadLayout("dialogcombo_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & prompt
	cbx.cmbBox.Clear
	cbx.mBase.Visible = True
	cbx1.mBase.Visible = False
	Dim lst As List = Main.ds.get_course_records
	Dim cbxlst As List
	cbxlst.Initialize
	courseindexes.Clear
	For i = 0 To lst.Size -1
		Dim mrowid As Int = lst.Get(i).As(course).rowid
		Dim mname As String = lst.Get(i).As(course).name
		Dim mdescription As String = lst.Get(i).As(course).description
		cbxlst.Add(mname & " " & mdescription)
		courseindexes.Add(mrowid)
	Next
	cbx.SetItems(cbxlst)
	If value > 0 Then
		cbx.SelectedIndex = value-1
	Else
		cbx.SelectedIndex = 0
	End If
	lblcbx.Text = cbx.SelectedIndex
	lblcbx.Tag = "lbl_" & fldindex
	Return p
End Sub
Private Sub cbx_SelectedIndexChanged (Index As Int)
	Log("changed index: " & Index)
	lblcbx.Text = Index
End Sub
Private Sub set_dialog_combo2(prompt As String, value As String, fldindex As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,90dip)
	p.LoadLayout("dialogcombo_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & prompt
	cbx1.cmbBox.Clear
	cbx.mBase.Visible = False
	cbx1.mBase.Visible = True
	Dim lst As List = Main.ds.get_student_records
	Dim cbxlst As List
	cbxlst.Initialize
	studentindexes.Clear
	For i = 0 To lst.Size -1
		Dim mrowid As Int = lst.Get(i).As(student).rowid
		Dim mfirstname As String = lst.Get(i).As(student).firstname
		Dim mlastname As String = lst.Get(i).As(student).lastname
		cbxlst.Add(mfirstname & " " & mlastname)
		studentindexes.Add(mrowid)
	Next
	Log(cbxlst)
	cbx1.SetItems(cbxlst)
	If value > 0 Then
		cbx1.SelectedIndex = value-1
	Else
		cbx1.SelectedIndex = 0
	End If
	lblcbx1.Text = cbx1.SelectedIndex
	lblcbx1.Tag = "lbl1_" & fldindex
	Return p
End Sub
Private Sub cbx1_SelectedIndexChanged (Index As Int)
	Log("changed index: " & Index)
	lblcbx1.Text = Index
End Sub
Private Sub show_opendialog
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 300dip, 190dip)
	pnl.LoadLayout("opendialog_layout")
	lbltitle.Text = "Open CSV import file"
	lbltitle.Padding = Array As Int (3dip, 0dip, 3dip, 0dip)
	Dim rs As ResumableSub =  opendialog.ShowCustom(pnl, "OK", "", "CANCEL")
	fillcbxopen
	Wait For (rs) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		import_csv
		B4XPage_Appear
	End If
End Sub
Private Sub fillcbxopen
	Private lst As List = File.ListFiles(B4XPages.MainPage.importfolder)
	If lst.Size > 0 Then
		cbxopen.SetItems(lst)
		cbxopen.SelectedIndex = 0
		edtopen.Text = cbxopen.SelectedItem
	End If
End Sub
Private Sub cbxopen_SelectedIndexChanged (Index As Int)
	edtopen.Text = cbxopen.SelectedItem
End Sub
Private Sub import_csv
	Dim reclst As List = File.ReadList(B4XPages.MainPage.importfolder,edtopen.text)
	Log(reclst)
	For i = 1 To reclst.Size -1
		Dim rec As String = reclst.Get(i)
		Dim flds() As String = Regex.Split(";",rec)
		Dim lst As List
		lst.Initialize
		For x = 0 To flds.Length -1
			lst.Add(flds(x))
		Next
		Main.db.add_record("enrollment", lst)
	Next
End Sub
