﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private cbxtest As B4XComboBox
	Private clvscore As CustomListView
	Private edtcomment As EditText
	Private edtscore As EditText
	Private lblstudent As Label
	Private testindexes As List
	Private clvdialog As CustomListView
	Private lbltitle As Label
	Private lblhint As Label
	Private dialog As B4XDialog
End Sub

Public Sub Initialize As Object
	Return Me
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("scorepage_layout")
	B4XPages.SetTitle(Me,"Gradebook - Score")
	dialog.Initialize(Root)
	dialog.PutAtTop = True
	dialog.BackgroundColor = Colors.LightGray
	dialog.BodyTextColor = Colors.Blue
	testindexes.Initialize
End Sub
Private Sub B4XPage_Appear
	fill_cbxtest
	fill_clvscore
End Sub
Private Sub fill_cbxtest
	cbxtest.cmbBox.Clear
	Dim lst As List = Main.ds.get_test_records
	Dim cbxlst As List
	cbxlst.Initialize
	testindexes.Clear
	For i = 0 To lst.Size -1
		Dim mrowid As Int = lst.Get(i).As(test).rowid
		Dim mdate As String = lst.Get(i).As(test).date
		Dim mtime As String = lst.Get(i).As(test).time
		Dim mdescription As String = lst.Get(i).As(test).description
		Dim mmaxscore As Int = lst.Get(i).As(test).maxscore
		cbxlst.Add("[" & mmaxscore & "] " & mdescription & " " &  mdate & " " & mtime)
		testindexes.Add(mrowid)
	Next
	cbxtest.SetItems(cbxlst)
	cbxtest.SelectedIndex = 0
End Sub
Private Sub fill_clvscore
	clvscore.Clear
	Dim mrowid As Int = testindexes.get(cbxtest.SelectedIndex)
	Dim lst As List = Main.ds.get_test_participants(mrowid)
	Log(lst)
	If lst.Size > 0 Then
		For i = 0 To lst.Size -1
			Dim rec As String = lst.Get(i)
			Dim flds() As String = Regex.Split(";",rec)
			' student.rowid - firstname - lastname
			Dim item As String = flds(0) & " " & flds(1) & " " & flds(2)
			Dim mscore As score = Main.ds.get_student_test_score_information(mrowid,flds(0))
			Dim strscore As String = mscore.score
			If strscore = -1 Then strscore = ""
			item = item & " score: " & strscore
			clvscore.AddTextItem(item,flds(0))
		Next
	End If
End Sub
Private Sub clvscore_ItemClick (Index As Int, Value As Object)
	Dim mstudent_id As Int = Value 
	Dim mstudent As student = Main.ds.get_student_information(mstudent_id)
	Dim mtest_id As Int = testindexes.get(cbxtest.SelectedIndex)
	Dim mscore As score = Main.ds.get_student_test_score_information(mtest_id,mstudent_id)
	Log(mscore.score & " " & mscore.comment)
	If mscore.score <> -1 Then
		show_dialog(mstudent,"change",mscore)		
	Else
		show_dialog(mstudent,"add",mscore)
	End If
End Sub
Private Sub cbxtest_SelectedIndexChanged (Index As Int)
	cbxtest.SelectedIndex = Index
	fill_clvscore
End Sub
private Sub show_dialog(mstudent As student,action As String,mscore As score)
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 200dip)
	pnl.LoadLayout("dialog_layout")
	clvdialog.Clear
	Dim strscore As String = mscore.score
	Dim strstudent As String = mstudent.firstname & " " & mstudent.lastname
	If strscore = -1 Then strscore = ""
	Dim pn As Panel = set_dialog_field(cbxtest.SelectedItem,strstudent,strscore,mscore.comment)
	clvdialog.Add(pn,"")
	lbltitle.Text = action & " score"
	lbltitle.Padding = Array As Int (3dip, 0dip, 3dip, 0dip)
	Wait For (dialog.ShowCustom(pnl, "SAVE", "DELETE", "CANCEL")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		Dim valuelst As List = set_values_list(mstudent)
		If action = "change" Then
			Main.db.change_record("score", valuelst,mscore.rowid)
		Else
			Main.db.add_record("score", valuelst)
		End If
		fill_clvscore
	End If
	If Result = xui.dialogResponse_Negative Then
		Dim valuelst As List = set_values_list(mstudent)
		Main.db.remove_record("score",mscore.rowid)
		fill_clvscore
	End If
End Sub
Private Sub set_dialog_field(mhint As String,mstudent As String, mvalue As String,mcomment As String) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,165dip)
	p.LoadLayout("dialogitem3_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & mhint
	lblstudent.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblstudent.Text = " " & mstudent
	edtscore.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	edtscore.Text = mvalue
	edtscore.Tag = "edt_1"
	edtcomment.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	edtcomment.Text = mcomment
	edtcomment.Tag = "edt_2"
	Return p
End Sub
Private Sub set_values_list(mstudent As student) As List
	Dim vlst As List
	vlst.Initialize
	For i = 0 To clvdialog.Size -1
		Dim pnlitem As Panel = clvdialog.GetPanel(i)
		For Each vw As View In pnlitem.GetAllViewsRecursive
			Dim tg As String = vw.Tag
			If tg.StartsWith("edt_") Then
				vlst.Add(vw.As(EditText).Text)
			End If
		Next
	Next
	vlst.Add(mstudent.rowid)
	Dim mtest_id As Int = testindexes.get(cbxtest.SelectedIndex)
	vlst.Add(mtest_id)
	Log(vlst)
	Return vlst
End Sub
