﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private clvstudent As CustomListView
	Private sbtnadd As SwiftButton
	Private dialog As B4XDialog
	Private clvdialog As CustomListView
	Private lbltitle As Label
	Private edt As EditText
	Private lblhint As Label
	Private cbx As B4XComboBox
	Private lblcbx As Label
	Private classindexes As List
	Private opendialog As B4XDialog
	Private cbxopen As B4XComboBox
	Private edtopen As EditText
End Sub
Public Sub Initialize As Object
	Return Me
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("studentpage_layout")
	B4XPages.SetTitle(Me,"Gradebook - Student")
	menuitem_add(Me, "CSV import")
	dialog.Initialize(Root)
	dialog.PutAtTop = True
	dialog.BackgroundColor = Colors.LightGray
	dialog.BodyTextColor = Colors.Blue
	opendialog.Initialize(Root)
	opendialog.PutAtTop = True
	opendialog.BackgroundColor = Colors.LightGray
	opendialog.BodyTextColor = Colors.Blue
	classindexes.Initialize
End Sub
Private Sub B4XPage_Appear
	fill_clvstudent
End Sub
Private Sub menuitem_add(objpage As Object, itemname As String)
	Private mnuitem As B4AMenuItem = B4XPages.AddMenuItem(objpage,itemname)
	mnuitem.AddToBar = False
End Sub
Sub B4XPage_MenuClick (Tag As String)
	If Tag = "CSV import" Then
		show_opendialog
	End If
End Sub
private Sub fill_clvstudent
	clvstudent.Clear
	Dim lst As List = Main.ds.get_student_records
	If lst.Size > 0 Then
		For i = 0 To lst.Size -1
			Dim mstudent As student = lst.Get(i)
			Dim mclass As class = Main.ds.get_class_information(mstudent.class_id)
			Dim item As String = mstudent.rowid & ". "  & mstudent.firstname & " " & mstudent.lastname & " " & mstudent.birthdate & " " & mclass.shortname
			clvstudent.AddTextItem(item,mstudent)
		Next
	End If
End Sub
Private Sub clvstudent_ItemClick (Index As Int, Value As Object)
	Log("index: " & Index & " value: " & Value)
	Dim mstudent As student = Value
	show_dialog(mstudent,"change")
End Sub
Private Sub sbtnadd_Click
	Dim mstudent As student
	mstudent.Initialize
	show_dialog(mstudent,"add")
End Sub
private Sub show_dialog(mstudent As student,action As String)
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 200dip)
	pnl.LoadLayout("dialog_layout")
	clvdialog.Clear
	Dim pn As Panel = set_dialog_field("firstname",mstudent.firstname,1)
	clvdialog.Add(pn,mstudent.firstname)
	Dim pn As Panel = set_dialog_field("lastname",mstudent.lastname,2)
	clvdialog.Add(pn,mstudent.lastname)
	Dim pn As Panel = set_dialog_field("birthdate",mstudent.birthdate,3)
	clvdialog.Add(pn,mstudent.birthdate)
	Dim pn As Panel = set_dialog_combo("class_id",mstudent.class_id,4)
	clvdialog.Add(pn,mstudent.class_id)
	lbltitle.Text = action & " student " & mstudent.firstname & " " & mstudent.lastname
	lbltitle.Padding = Array As Int (3dip, 0dip, 3dip, 0dip)
	Wait For (dialog.ShowCustom(pnl, "SAVE", "DELETE", "CANCEL")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		Dim valuelst As List = set_values_list
		If action = "change" Then
			Main.db.change_record("student", valuelst,mstudent.rowid)
		Else
			Main.db.add_record("student", valuelst)
		End If
		B4XPage_Appear
	End If
	If Result = xui.dialogResponse_Negative Then
		Dim valuelst As List = set_values_list
		Main.db.remove_record("student",mstudent.rowid)
		B4XPage_Appear
	End If
End Sub
Private Sub set_dialog_field(prompt As String, value As String, fldindex As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,90dip)
	p.LoadLayout("dialogitem_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & prompt
	edt.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	edt.Text = value
	edt.Tag = "edt_" & fldindex
	Return p
End Sub
Private Sub set_values_list As List
	Dim vlst As List
	vlst.Initialize
	For i = 0 To clvdialog.Size -1
		Dim pnlitem As Panel = clvdialog.GetPanel(i)
		For Each vw As View In pnlitem.GetAllViewsRecursive
			Dim tg As String = vw.Tag
			If tg.StartsWith("edt_") Then
				vlst.Add(vw.As(EditText).Text)
			End If
			If tg.StartsWith("lbl_") Then
				lblcbx.text = vw.As(Label).Text
				Dim index As Int = lblcbx.Text
				Log(index)
				vlst.Add(classindexes.Get(index))
			End If
		Next
	Next
	Log(vlst)
	Return vlst
End Sub
Private Sub set_dialog_combo(prompt As String, value As String, fldindex As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("p")
	p.SetLayoutAnimated(0,0dip,2dip,340dip,90dip)
	p.LoadLayout("dialogcombo_layout")
	lblhint.Padding = Array As Int (3dip, 3dip, 3dip, 3dip)
	lblhint.Text = " " & prompt
	cbx.cmbBox.Clear
	Dim lst As List = Main.ds.get_class_records
	Dim cbxlst As List
	cbxlst.Initialize
	classindexes.Clear
	For i = 0 To lst.Size -1
		Dim mrowid As Int = lst.Get(i).As(class).rowid
		Dim mshort As String = lst.Get(i).As(class).shortname
		Dim mlong As String = lst.Get(i).As(class).longname
		cbxlst.Add(mshort & " " & mlong)
		classindexes.Add(mrowid)
	Next
	cbx.SetItems(cbxlst)
	If value > 0 Then
		cbx.SelectedIndex = value-1
	Else
		cbx.SelectedIndex = 0		
	End If
	lblcbx.Text = cbx.SelectedIndex
	lblcbx.Tag = "lbl_" & fldindex
	Return p
End Sub
Private Sub cbx_SelectedIndexChanged (Index As Int)
	lblcbx.Text = Index
End Sub
Private Sub show_opendialog
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, 300dip, 190dip)
	pnl.LoadLayout("opendialog_layout")
	lbltitle.Text = "Open CSV import file"
	lbltitle.Padding = Array As Int (3dip, 0dip, 3dip, 0dip)
	Dim rs As ResumableSub =  opendialog.ShowCustom(pnl, "OK", "", "CANCEL")
	fillcbxopen
	Wait For (rs) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		import_csv
		B4XPage_Appear
	End If
End Sub
Private Sub fillcbxopen
	Private lst As List = File.ListFiles(B4XPages.MainPage.importfolder)
	If lst.Size > 0 Then
		cbxopen.SetItems(lst)
		cbxopen.SelectedIndex = 0
		edtopen.Text = cbxopen.SelectedItem
	End If
End Sub
Private Sub cbxopen_SelectedIndexChanged (Index As Int)
	edtopen.Text = cbxopen.SelectedItem	
End Sub
Private Sub import_csv
	Dim reclst As List = File.ReadList(B4XPages.MainPage.importfolder,edtopen.text)
	Log(reclst)
	For i = 1 To reclst.Size -1
		Dim rec As String = reclst.Get(i)
		Dim flds() As String = Regex.Split(";",rec)
		Dim lst As List
		lst.Initialize
		For x = 0 To flds.Length -1
			lst.Add(flds(x))
		Next
		Main.db.add_record("student", lst)
	Next
End Sub